﻿using Hotline.Share.Requests;

namespace Hotline.Share.Dtos.Bi
{
    public record VisitAndOrgSatisfactionDetailDto : PagedRequest
    {
        public DateTime StartTime { get; set; }
        public DateTime EndTime { get; set; }
        public string OrgCode { get; set; }
        public int TypeId { get; set; }
        public string DateValue { get; set; }

        public string? LineNum { get; set; }

        /// <summary>
        /// 是否只看自己（优先级最高）
        /// </summary>
        public bool? IsOnlyMy { get; set; }

        /// <summary>
        /// 来电/信人身份0：全部 ，1：市民，2：企业
        /// </summary>
        public int? TypeCode { get; set; }
    }

    public record HighFrequencyCallStatisticsRequest : PagedRequest
    {
        public DateTime? StartTime { get; set; }
        public DateTime? EndTime { get; set; }

        public string? PhoneNum { get; set; }
    }

    public record HighMatterWarningRequest : PagedRequest
    {
        public DateTime StartTime { get; set; }
        public DateTime EndTime { get; set; }

        public string Hotspot { get; set; }

        public string AreaCode { get; set; }

        public string AcceptType { get; set; }
    }

    public record HighMatterWarningDetailRequest : PagedRequest
    {
        public DateTime StartTime { get; set; }
        public DateTime EndTime { get; set; }

        public string HotspotId { get; set; }

        public string AreaCode { get; set; }

        public string AcceptTypeCode { get; set; }
    }
}
